import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:pub_semver/pub_semver.dart'; // ignore: import_of_legacy_library_into_null_safe

part 'version_info.freezed.dart';
part 'version_info.g.dart';

@freezed
@internal
abstract class VersionInfo with _$VersionInfo {
  const factory VersionInfo({
    @JsonKey(
      fromJson: VersionInfo._versionFromJson,
      toJson: VersionInfo._versionToJson,
    )
        required Version? version,
    bool? nullSafety,
  }) = _VersionInfo;

  factory VersionInfo.fromJson(Map<String, dynamic> json) =>
      _$VersionInfoFromJson(json);

  static String? _versionToJson(Version? version) => version?.toString();

  static Version? _versionFromJson(String? version) =>
      version != null ? Version.parse(version) : null;
}
